library pourscilab_fp_c;

{$mode delphi}{$H+}

uses
  Classes,sysutils,Dynlibs
  { you can add units after this };
// (C) Pierre Dieumegard 2012 pierre.dieumegard@free.fr  http://sciencexp.free.fr
// logiciel libre / libera programaro / free software / Freie Software / software libre


//pour l'adaptation des pilotes d'appareils de mesure de Mensurasoft à Scilab
//à compiler par Lazarus avec l'option de compatibilité Delphi
//Pour Delphi : remplacer Dynlibs par wintypes
{$mode delphi}
type pdouble=^double;
     pword=^word;
var detail,titre:function:pchar; cdecl;
var nea,nsb,nsa,nsad : function(n:integer):pchar;cdecl;
    nead,nsvd:function(n:integer):pchar;cdecl;
var ea : function(n:integer):integer;cdecl;
    ead:function(n:integer):double;cdecl;
    eb:function(n:integer):integer; cdecl;
    neb:function(n:integer):pchar;cdecl;
    sb:function(n:integer;etat:integer):integer;cdecl;

    sa,sv:function(n:integer;valeur:integer):integer; cdecl;
    rsb:function(n:integer):integer;  cdecl;
    rsa:function(n:integer):integer;cdecl;
    rsad:function(n:integer):double; cdecl;
    sad,svd:function(n:integer;valeur:double):double;cdecl;
    sadouble:function(n:double;valeur:double):double;cdecl;
    calibration:function(pch:pchar):pchar;cdecl;

function chargedllnormale( ch:pchar;var res:word):word; cdecl; export;
var L:thandle; chloc:string;
begin
chloc:=string(ch);
  res:=ord(chloc[1]);
  chargedllnormale:=res;
   @detail:=nil;
   @calibration:=nil;
   @sa:=nil;
   @sad:=nil;
   @sadouble:=nil;
   @titre:=nil;
     @nsad:=nil;@nsa:=nil;   @titre:=nil;
     @ead:=nil; @ea:=nil;
     @nead:=nil; @nea:=nil;
     @sb:=nil;@nsb:=nil; @rsa:=nil; @rsad:=nil; @rsb:=nil;
     @eb:=nil;@neb:=nil;
            L:=loadlibrary(ch);
                @detail:=getprocaddress(L,'cdetail');
                @titre:=getprocaddress(L,'ctitre');
                @nea:=getprocaddress(L,'cnea');
                @ea:=getprocaddress(L,'cea');
                @nead:=getprocaddress(L,'cnead');
                @ead:=getprocaddress(L,'cead');
                @sa:=getprocaddress(L,'csa');
                @sad:=getprocaddress(L,'csad');
                @sadouble:=getprocaddress(L,'csadouble');
                @nsa:=getprocaddress(L,'cnsa');
                @nsad:=getprocaddress(L,'cnsad');
                @sb:=getprocaddress(L,'csb');
                @nsb:=getprocaddress(L,'cnsb');
                @eb:=getprocaddress(L,'ceb');
                @neb:=getprocaddress(L,'cneb');
                @rsa:=getprocaddress(L,'crsa');
                @rsad:=getprocaddress(L,'crsad');
                @rsb:=getprocaddress(L,'crsb');
                @calibration:=getprocaddress(L,'ccalibration');
  end;

function cdetail(var res:pchar):pchar;cdecl;export;
begin
  res:=detail;
  cdetail:=res;
end;

function normdetail(n:pword;var res :word):word;cdecl; export;
var wloc:word;chloc:string;
begin
  wloc:=n^;
  chloc:=string(detail);
  res:=ord(chloc[wloc]);
  normdetail:=res;
  end;

function normtitre(n:pword ; var res:word):word;cdecl; export;
var wloc:word; chloc:string;
begin
  wloc:=n^;
  chloc:=string(titre);
  res:=ord(chloc[wloc]);
  normtitre:=res;
  end;

function normnea(n,i:pword;var res:word):word;cdecl;export;
var chloc:string;    wloc1,wloc2:word;
begin
wloc1:=n^;
chloc:=string(nea(wloc1));
wloc2:=i^;
if length(chloc)>0 then res:=ord(chloc[wloc2])  else res:=0;;
normnea:=res;
end;

function normnead(n,i:pword;var res:word):word;cdecl;export;
var chloc:string;   wloc:word;
begin
wloc:=n^;
chloc:=string(nead(wloc));
wloc:=i^;
if length(chloc)>0 then res:=ord(chloc[wloc]) else res:=0;
normnead:=res;
end;

function normea(n:pword;var res:word):word;cdecl; export;
var wloc:word;
begin
wloc:=n^;
res:=ea(wloc);
normea:=res;
end;

function normead(n:pword;var res:double):double;cdecl; export;
var wloc:word;
begin
 wloc:=n^;
 res:=ead(wloc);
normead:=res;
end;

function normnsad(n,i:pword;var res:word):word;cdecl; export;
var chloc:string;    wloc:word;
begin
wloc:=n^;
chloc:=string(nsad(wloc));
wloc:=i^;
if length(chloc)>0 then res:=ord(chloc[wloc]) else res:=0;
normnsad:=res;
end;

function normsad(n:pword;v:pdouble;var res:double):double;cdecl; export;
var wloc:word;     dloc:double;
begin
wloc:=n^;
dloc:=v^;
res:=sad(wloc,dloc);
normsad:=res;end;

function normnsa(n,i:pword;var res:word):word;cdecl; export;
var chloc:string;   wloc:word;
begin
  wloc:=n^;
  chloc:=string(nsa(wloc));
  wloc:=i^;
  if length(chloc)>0 then res:=ord(chloc[wloc])    else res:=0;
  normnsa:=res;
  end;

function normsa(n:pword;v:pword;var res:word):word; cdecl;export;
var wloc1,wloc2:word;
begin
wloc1:=n^; wloc2:=v^;
res:=sa(wloc1,wloc2);
normsa:=res;end;

function normneb(n,i:pword;var res:word):word;cdecl; export;
var chloc:string;      wloc:word;
begin
wloc:=n^;
chloc:=string(neb(wloc));
wloc:=i^;
if length(chloc)>0 then res:=ord(chloc[wloc]) else res:=0;
 normneb:=res;
 end;

function normeb(n:pword;var res:word):word;cdecl; export;
var wloc:word;
begin
wloc:=n^;
res:=eb(wloc);
normeb:=res;end;

function normnsb(n,i:pword;var res:word):word;cdecl; export;
var chloc:string;    wloc:word;
begin
wloc:=n^;
chloc:=string(nsb(wloc));
wloc:=i^;
if length(chloc)>0 then res:=ord(chloc[wloc]) else res:=0;
normnsb:=res;
end;

function normsb(n,v:pword;var res:word):word;  cdecl;export;
var wloc1,wloc2:word;
begin
wloc1:=n^;wloc2:=v^;
res:=sb(wloc1,wloc2);
normsb:=res;end;

exports
  chargedllnormale,
  cdetail,normdetail,normtitre,normnea,normnead,normea,normead,
  normnsa,normsa,normnsad,normsad,
  normneb,normeb,   normnsb,normsb ;

begin
end.

