//script_charge_bibdyn_normale_scilab5_2012_04.sce
// Script pour pouvoir utiliser avec Scilab les pilotes
// d'appareils de mesure ou d'actionneurs d'exprimentation 
// assiste par ordinateur.
// Consultez http://sciencex.free.fr
//(C) Auteur : Pierre Dieumegard (pierre.dieumegard@ac-orleans-tours.fr) 
// Logiciel libre -- libera programaro -- free software -- 
//nomadaptateur='./pourscilab_lazarus2.dll';//  changer selon les circonstances


global numh
if getos()=='Windows'
  nomadaptateur='./pourscilab_fp_c.dll';;
else 
 nomadaptateur='./libpourscilab_fp_c.so';;
end

nomfich=uigetfile("*"+getdynlibext());

if length(nomfich)>1
  numh=link(nomadaptateur,'chargedllnormale','c');
  x=call('chargedllnormale',nomfich,1,'c','out',[1,1],2,'i');
  numh=link(nomadaptateur,'normdetail','c');
  numh=link(nomadaptateur,'normtitre','c');
  numh=link(nomadaptateur,'normnea','c');
  numh=link(nomadaptateur,'normnead','c');
  numh=link(nomadaptateur,'normea','c');
  numh=link(nomadaptateur,'normead','c');
  numh=link(nomadaptateur,'normnsa','c');
  numh=link(nomadaptateur,'normsa','c');
  numh=link(nomadaptateur,'normnsad','c');
  numh=link(nomadaptateur,'normsad','c');
  numh=link(nomadaptateur,'normneb','c');
  numh=link(nomadaptateur,'normeb','c');
  numh=link(nomadaptateur,'normnsb','c');
  numh=link(nomadaptateur,'normsb','c');
else disp('pas de pilote charg !');
end;
function res = normnea(n,i);
    res=uint16(call('normnea',n,1,'i',i,2,'i','out',[1,1],3,'i'));
endfunction;

function res=nea(n);
    ch='';
    if getos()=='Windows'
    i=1;
    while normnea(n,i)>0
        ch=ch+char(normnea(n,i));
        i=i+1;
    end;
    res=ch;
  else //Linux
    for i=1:30
  ch=ch+char(normnea(n,i));
end;
ch2='';
for i=1:30
  if ascii(part(ch,i))>0
    ch2=ch2+part(ch,i);
  end
end
res=ch2; 
end;
endfunction;

function res = normnead(n,i);
    res=uint16(call('normnead',n,1,'i',i,2,'i','out',[1,1],3,'i'));
endfunction;

function res=nead(n);
    ch='';
    if getos()=='Windows'
    i=1;
    while normnead(n,i)>0
        ch=ch+char(normnead(n,i));
        i=i+1;
    end;
    res=ch;
  else //Linux
    for i=1:30
  ch=ch+char(normnead(n,i));
end;
ch2='';
for i=1:30
  if ascii(part(ch,i))>0
    ch2=ch2+part(ch,i);
  end
end
res=ch2; 
end;
endfunction;

function res=ead(n);
    res=call('normead',n,1,'i','out',[1,1],2,'d');
endfunction;


function res=normea(n);
    //disp(n);
    res=call('normea',n,1,'i','out',[1,1],2,'i');
endfunction;

function res=ea(n);
    res=normea(n);
endfunction;


function res = normnsa(n,i);
    res=uint16(call('normnsa',n,1,'i',i,2,'i','out',[1,1],3,'i'));
endfunction;

function res=nsa(n);
    ch='';
    if getos()=='Windows'
    i=1;
    while normnsa(n,i)>0
        ch=ch+char(normnsa(n,i));
        i=i+1;
    end;
    res=ch;
  else //Linux
    for i=1:30
  ch=ch+char(normnsa(n,i));
end;
ch2='';
for i=1:30
  if ascii(part(ch,i))>0
    ch2=ch2+part(ch,i);
  end
end
res=ch2; 
end;
endfunction;

function res=normsa(n,v);
    //disp(n);
    res=call('normsa',n,1,'i',v,2,'i','out',[1,1],3,'i');
endfunction;

function res=sa(n,v);
    res=normsa(n,v);
endfunction;


function res = normnsad(n,i);
    res=uint16(call('normnsad',n,1,'i',i,2,'i','out',[1,1],3,'i'));
endfunction;

function res=nsad(n);
    ch='';
    if getos()=='Windows'
    i=1;
    while normnsad(n,i)>0
        ch=ch+char(normnsad(n,i));
        i=i+1;
    end;
    res=ch;
  else //Linux
    for i=1:30
  ch=ch+char(normnsad(n,i));
end;
ch2='';
for i=1:30
  if ascii(part(ch,i))>0
    ch2=ch2+part(ch,i);
  end
end
res=ch2; 
end;
endfunction;


function res=normsad(n,v);
    //disp(n);
    res=call('normsad',n,1,'i',v,2,'d','out',[1,1],3,'d');
endfunction;

function res=sad(n,v);
    res=normsad(n,v);
endfunction;


function res = normneb(n,i);
    res=uint16(call('normneb',n,1,'i',i,2,'i','out',[1,1],3,'i'));
endfunction;


function res=neb(n);
  ch='';
  if getos()=='Windows'
    i=1;
    while normneb(n,i)>0
        ch=ch+char(normneb(n,i));
        i=i+1;
    end;
    res=ch;
  else   tableau=[];
     for k=0:20   
       tableau=[tableau,normneb(n,k)];
         end;
     tableau=[];
     for k=1:20   
       tableau=[tableau,normneb(n,k)];
      if normneb(n,k)==0;    break;;     end;
end;
   // disp(tableau) ;
    res=char(tableau);
end;
endfunction;


function res=normeb(n);
    //disp(n);
    res=call('normeb',n,1,'i','out',[1,1],2,'i');
endfunction;

function res=eb(n);
    res=normeb(n);
endfunction;

function res = normnsb(n,i);
    res=uint16(call('normnsb',n,1,'i',i,2,'i','out',[1,1],3,'i'));
endfunction;

function res=nsb(n);
    ch='';
    if getos()=='Windows'
    i=1;
    while normnsb(n,i)>0
        ch=ch+char(normnsb(n,i));
        i=i+1;
    end;
    res=ch;
  else //Linux
       tableau=[];
     for k=0:20   
       tableau=[tableau,normnsb(n,k)];
         end;
     tableau=[];
     for k=1:20   
       tableau=[tableau,normnsb(n,k)];
      if normnsb(n,k)==0;    break;;     end;
end;
   // disp(tableau) ;
    res=char(tableau);
end;
endfunction;

function res=normsb(n,v);
    //disp(n);
    res=call('normsb',n,1,'i',v,2,'i','out',[1,1],3,'i');
endfunction;

function res=sb(n,v);
    res=normsb(n,v);
endfunction;


  


function res = normdetail(n);
    res=uint16(call('normdetail',n,1,'i','out',[1,1],2,'i'));
endfunction;
//script_detail
function res=detail();
  ch='';
  if getos()=='Windows'
    i=1;
    while normdetail(i)>0
        ch=ch+char(normdetail(i));
        i=i+1;
    end;
    res=ch;
  else //Linux
    //tableau=[normtitre(1)]; 
 
ch='';tableau=[];
for k=1:80
  ch=ch+char(uint8(normdetail(k)));
  tableau=[tableau,normdetail(k)];
  if uint8(normdetail(k))==0
    break;
    end;
  end
 // disp(tableau);
 // disp(size(tableau));
//disp(ch);
//res=char(tableau);
res=ch;
   // disp('tableau:'+char(tableau));
  end;
  
endfunction;
function res = normtitre(n);
    res=uint16(call('normtitre',n,1,'i','out',[1,1],2,'i'));
endfunction;

function res=titre();
  ch='';
  if getos()=='Windows'
    i=1;
    while normtitre(i)>0
        ch=ch+char(normtitre(i));
        i=i+1;
    end;
    res=ch;
  else //Linux
    //tableau=[normtitre(1)]; 
  
        tableau=[];
     for k=0:20   
       tableau=[tableau,normtitre(k)];
         end;
     tableau=[];
     for k=1:20   
       tableau=[tableau,normtitre(k)];
      if normtitre(k)==0;    break;;     end;
end;
   // disp(tableau) ;
    res=char(tableau);
   // disp('tableau:'+char(tableau));
  end;
  
endfunction;

disp('script4 fait');
disp('vous pouvez maintenant utiliser les fonctions suivantes :');
disp('ea, nea, ead, nead, sa, nsa, sad, nsad, eb, neb, sb, nsb,');
disp('detail et titre.');

